/* Exercice 1 */

/* Question 1 */
/* Création d'un jeu de données */
Data notes;
input nom$ semestre$ a_naiss moyenne; /*$ pour les chaines de caractères*/
datalines; /*DATALINES pour insérer des données en ligne*/
Ricco S1 1953 7
Julien S2 1967 12
Omar S1 1940 3
Fadila S1 1973 14
;/* le délimiteur est l'espace*/
run; /* Fin de l'instruction*/

/*Question2*/
/* changer le délimiteur */
Data notes_2; /*Création d'un autre jeu de données */
infile datalines delimiter=','; /* On definit le delimiteur comme virgule*/
input nom$ semestre$ a_naiss moyenne;
datalines; 
Ricco Rakotomalala,S1,1953,7
Julien Jacques,S2,1967 ,2
Omar Boussaid,S1,1940,3
Fadila Bentayeb,S1,1973,14
;
run;

/*Question 3*/
/*Le jeu de données notes_2 sera ecrasé et remplacé par celui ci-dessous*/
Data notes_2;
length nom $20;/* augementer la taille de la variable nom */
infile datalines delimiter=',';
input nom$ semestre$ a_naiss moyenne;
datalines; 
Ricco Rakotomalala,S1,1953,7
Julien Jacques,S2,1967 ,2
Omar Boussaid,S1,1940,3
Fadila Bentayeb,S1,1973,14
run;


/* Question 4*/
/* Format Date*/ 
/* Attention la date est sous forme de nombre : elle est calculée à partir du 1er Janvier 1960. Si la date est antérieure, le nombre sera négatif*/
/*C'est pour cela qu'on utilise le format : DDMMYY10.*/
Data notes_2;
length nom $20;/* on définit la taille de la variable nom : cette variable pourra prendre jusqu'a 20 caractères*/
infile datalines delimiter=',';
input nom$ semestre$ a_naiss moyenne;
format a_naiss DDMMYY10.; /*Précise que la variable a_naiss est de ce format(le format date)*/
informat a_naiss DDMMYY10.; /* pour afficher sous ce format*/
DATALINES;
Ricco Rakotomalala,S1,23.10.1953,7 /*Ici, la date peut s'écrire de différente manière : avec un point, un / */
Julien Jacques,S2,12031967 ,2 /*ou bien on peut écrire les nombres de la date sans séparateur*/
Omar Boussaid,S1,29/06/1940,3 
Fadila Bentayeb,S1,24/09/1980,14
;
run;

/*question 5 */
data notes_2;
set notes_2 end=eof;/* on définit la fin de notre jeu de données comme étant eof. */
output;
if eof then /* avec une boucle, à la fin de notre jeu de données on ajouute un enregistrement*/
do; 
nom='Julien Lemaire';
semestre='S2';
a_naiss=mdy(01,06,2000);/*attention le format date : mois, jour année*/
moyenne=15;
output;
end;
run;
/*on peut choisir les colonnes à remplir */

/*Question 6*/
/*On peut ajouter une colonne et lui spécifier les valeurs par lignes*/
data notes_2;
set notes_2;
   input bonus;
   datalines;
2
3
-1
2
2
;
run;


data notes_2;
set notes_2;
moyenne_finale=moyenne+bonus; /*Ajout d'une nouvelle colonne */
run;

/* question 7*/
data notes_2 (drop=semestre);/*Suppression de la colonne semestre*/
   set notes_2;
run;

/* suppression en fonction de l'index, ici l'enregistrement de la ligne 2 sera supprimé */
data notes_2;
   set notes_2;
   if _N_=2 then delete;
run; 

/*Question 8*/
/*supprimer une ligne qui contient  une valeur spécifique*/
data notes_2;
   set notes_2;
   if nom= 'Omar Boussaid' then delete; /*Ici, on supprime en fonction de la variable nom*/
run; 

/* question 9*/
data notes_2;
set notes_2;
rename a_naiss=date_naiss; /* on renome la variable a_nais et devient date_naiss*/
run;

data notes_2;
set notes_2; 
if moyenne_finale<10 then avis = 'ne passe pas'; /*avec la boucle on créé une nouvelle variable avis avec des conditions*/
else avis = 'passe' ;
run;

/* question 10 */
data note;  /*Création d'un jeu de données nommé note où on choisit les colonnes à garder du jeu de données notes_2*/
set notes_2;
keep moyenne_finale moyenne avis;
run;




/* Exercice 2 */

/* Définition de la librairie */
LIBNAME ex2 '/folders/myfolders/sasuser.v94/Exercice 2';

/* Import de données */
PROC IMPORT
	DATAFILE='/folders/myfolders/sasuser.v94/Exercice 2/sise_2019.txt'
	OUT=ex2.sise REPLACE
	DBMS=tab;
	DELIMITER=';';
	GETNAMES=yes;
RUN;

/* Informations sur la table */
PROC CONTENTS 
	DATA = ex2.sise;
RUN;

/* Renommer une variable */
DATA ex2.sise;
	SET ex2.sise;
	RENAME CP = Code_Postal;
RUN;

/* Créer une nouvelle variable avec une fonction */
DATA ex2.sise;
	SET ex2.sise;
	Appellation = SUBSTR(Prenom, 1, 1)||". "||Nom;
RUN;

/* Créer une nouvelle variable avec des calculs */
DATA ex2.sise;
	SET ex2.sise;
	BAC = (RAND('GAUSSIAN')*1.8)+15;
	IF BAC > 20 THEN BAC = 20;
RUN;

/* Format de la variable BAC */
DATA ex2.sise;
	SET ex2.sise;
	FORMAT BAC 7.2;
RUN;

/* Variable Age */
DATA ex2.sise;
	SET ex2.sise;
	Age = FLOOR((DATE()-Naissance)/365);
RUN;

/* Créer un nouveau format */
PROC FORMAT;
	VALUE Gender
		0 = "M"
		1 = "F" 
  		;
RUN;

/* Appliquer le format */
DATA ex2.sise;
	SET ex2.sise;
	FORMAT Sexe Gender.;
RUN;

/* Créer une variable avec des conditions */
DATA ex2.sise;
	SET ex2.sise;
	
	IF BAC < 8 THEN Mention = "NA";
	ELSE IF BAC < 10 THEN Mention = "R";
	ELSE IF BAC < 12 THEN Mention = "P";
	ELSE IF BAC < 14 THEN Mention = "AB";
	ELSE IF BAC < 16 THEN Mention = "B";
	ELSE Mention = "TB";
RUN;

/* Tri */
PROC SORT
	DATA = ex2.sise;
	BY DESCENDING Mention ;
RUN;

/* Afficher la sortie par mention */
PROC PRINT
	DATA=ex2.sise;
	BY NOTSORTED Mention;
RUN;



/* Exercice 3 */

/* Questions 1 et 2 */


/*on execute le programme suivant et  on regarde ce que fait le programme*/

%let N=100; /*on definit le nombre d'observations*/
data exemple_data(keep=a b c); /* on cree la table exemple_data qui contient trois variables : a, b, c*/
call streaminit(1); /*on fixe la graine aleatoire*/
do i=1 to &N; /*boucle for*/
a=rand('BERNOULLI',0.6); /* on genere des nombres aleatoires suivant une loi de bernouilli*/
b=rand('BINOMIAL',0.1,20);/* on genere des nombres aleatoires suivant une loi de binomiale de parametres 0.1, 20*/
c=rand('EXPONENTIAL');/* on genere des nombres aleatoires suivant une loi exponentielle*/
output;
end;
run;


/* Questions 3 A 4*/
data IMC(keep=Individu Poids Taille imc); /*creation de la table IMC*/
call streaminit(2);
a=55;
b=90;
c=-5;
d=5;

do i=1 to 1000;
	Individu=cats('individu',i); /* calcule  chaque iteration des observations de la variable individu, la fonction cats permet de concatener des strings et des nombres*/
	Poids=floor(a+(b-a)*rand('Uniform'));/* calcule  chaque iteration des observations de la variable Poids*, la fonction loor permet de prendre la partie entiere/
	Taille=100+Poids+floor(c+(d-c)*rand('Uniform'));/* calcule  chaque iteration des observations de la variable Taille*/
	imc=10000*Poids/(Taille*Taille);/* calcule  chaque iteration des observations de la variable imc, on multiplie par 10000 pour convertir la taille en metre*/
	
	output;
end;
run; 

/* Questions 5*/
data IMC; /*on cree la variable diagnostic de type caractere et de longueur maximale 40*/
set IMC;
length diagnostic$ 40;
run; 

/*on remplit la variable diagnostic avec les operateurs de conditions*/
data IMC ;
set IMC;
if (imc<=18.5) then diagnostic='Maigreur';
else if (imc<=25.9) then diagnostic='Normal';
else if (imc<=29.9) then diagnostic='Surpoids';
else if (imc<=40) then diagnostic='Obesite';
else diagnostic='Obseite massive';
run; 



